﻿//+--------------------------------------------------------------------------+
//|                                                                          |
//|                            Custom TRACKBAR                               |
//|                                                                          |
//+--------------------------------------------------------------------------+
//|                                                                          |
//|                         Author Patrice TERRIER                           |
//|                           copyright (c) 2006                             |
//|                                                                          |
//|                        pterrier@zapsolution.com                          |
//|                                                                          |
//|                          www.zapsolution.com                             |
//|                                                                          |
//+--------------------------------------------------------------------------+
//|                  Project started on : 12-10-2006 (MM-DD-YYYY)            |
//|                        Last revised : 12-15-2006 (MM-DD-YYYY)            |
//+--------------------------------------------------------------------------+

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using Win32;

namespace Trackbar
{
    public partial class MAIN_Form : Form
    {
        double[] TV = new double[10];
        IntPtr[] TH = new IntPtr[10];

        public MAIN_Form()
        {
            InitializeComponent();
        }

        private void MAIN_Load(object sender, EventArgs e)
        {
            // Save current Vista trackbar values and handles
            TV[0] = TRACK_80.Value; TH[0] = TRACK_80.Handle;
            TV[1] = TRACK_170.Value; TH[1] = TRACK_170.Handle;
            TV[2] = TRACK_310.Value; TH[2] = TRACK_310.Handle;
            TV[3] = TRACK_600.Value; TH[3] = TRACK_600.Handle;
            TV[4] = TRACK_1K.Value; TH[4] = TRACK_1K.Handle;
            TV[5] = TRACK_3K.Value; TH[5] = TRACK_3K.Handle;
            TV[6] = TRACK_6K.Value; TH[6] = TRACK_6K.Handle;
            TV[7] = TRACK_10K.Value; TH[7] = TRACK_10K.Handle;
            TV[8] = TRACK_12K.Value; TH[8] = TRACK_12K.Handle;
            TV[9] = TRACK_14K.Value; TH[9] = TRACK_14K.Handle;
        }

        private void TRACK_ValueChanged(object sender, EventArgs e)
        {
            SK_TRACK T = ((SK_TRACK)sender);
            string sName = T.Name;
            double n = T.Value;
            switch (T.Name)
            {
                case "HORZ_01":
                    HORZ_02.Value = HORZ_02.Minimum - n;
                    HORZ_03.Value = HORZ_03.Maximum - n;
                    break;
                case "VERT_01":
                    VERT_02.Value = VERT_02.Minimum - n;
                    VERT_03.Value = VERT_03.Maximum - n;
                    break;
                default:
                    break;
            }
        }

        private void VISTA_ValueChanged(object sender, EventArgs e)
        {
            VISTA_Track T = ((VISTA_Track)sender);
            IntPtr hTrack = T.Handle;
            if (hTrack == MASTER_Track.Handle)
            {// Move all Vista tracks based on value of MASTER_Track
                double n = T.Value / 50;
                Api.ControlDrawingDisable(VISTA_Panel.Handle);
                TRACK_80.Value = TV[0] * n;
                TRACK_170.Value = TV[1] * n;
                TRACK_310.Value = TV[2] * n;
                TRACK_600.Value = TV[3] * n;
                TRACK_1K.Value = TV[4] * n;
                TRACK_3K.Value = TV[5] * n;
                TRACK_6K.Value = TV[6] * n;
                TRACK_10K.Value = TV[7] * n;
                TRACK_12K.Value = TV[8] * n;
                TRACK_14K.Value = TV[9] * n;
                Api.ControlDrawingEnable(VISTA_Panel.Handle);
            }
            else
            {// Update TV[] with current value
                for (int i = TH.GetLowerBound(0); i <= TH.GetUpperBound(0); i++)
                {
                    if (TH[i] == hTrack) { TV[i] = T.Value; break; }
                }
            }
        }

        protected override void WndProc(ref Message m)
        {
            switch (m.Msg)
            {
                case Api.WM_COMMAND:
                    if (m.LParam == HORZ_01.Handle)
                    { }
                    else if (m.LParam == HORZ_02.Handle)
                    { }
                    else if (m.LParam == HORZ_03.Handle)
                    { }
                    else if (m.LParam == VERT_01.Handle)
                    { }
                    else if (m.LParam == VERT_02.Handle)
                    { }
                    else if (m.LParam == VERT_03.Handle)
                    { }
                    break;
                default:
                    break;
            }

            base.WndProc(ref m);
        }

    }
}