﻿//+--------------------------------------------------------------------------+
//|                                                                          |
//|                             SK_TRACK class                               |
//|                                                                          |
//+--------------------------------------------------------------------------+
//|                                                                          |
//|                         Author Patrice TERRIER                           |
//|                           copyright (c) 2006                             |
//|                                                                          |
//|                        pterrier@zapsolution.com                          |
//|                                                                          |
//|                          www.zapsolution.com                             |
//|                                                                          |
//+--------------------------------------------------------------------------+
//|                  Project started on : 10-17-2006 (MM-DD-YYYY)            |
//|                        Last revised : 12-15-2006 (MM-DD-YYYY)            |
//+--------------------------------------------------------------------------+

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;

using System.Drawing.Imaging;
using System.Drawing.Drawing2D;

using Win32;
//using SkinEngine;

namespace Trackbar
{
    public partial class SK_TRACK : UserControl
    {
        private const bool Vert = false;
        private const bool Horz = true;

        private double value = 50;
        private double minimum = 0;
        private double maximum = 100;

        private bool ThumbMoving = false;
        private static int WasValue = 0;

        public SK_TRACK()
        {
            InitializeComponent();
        }

        private void TRACK_Load(object sender, EventArgs e)
        {
            if (minimum == 0 && maximum == 0)
            {
                // Set default value
                value = 50;
                if (Orientation() == Horz)
                { minimum = 0; maximum = 100; }
                else
                { minimum = 100; maximum = 0; }
            }
            // FORM_Tooltip colors
            //toolTip.BackColor = SK.TooltipBackColor;
            //toolTip.ForeColor = SK.TooltipForeColor;
        }

        protected override void WndProc(ref Message m)
        {
            switch (m.Msg)
            {
                case Api.WM_ERASEBKGND:

                    // Create a memory bitmap to use as double buffer
                    Bitmap offScreenBmp;
                    offScreenBmp = new Bitmap(this.Width, this.Height);
                    Graphics g = Graphics.FromImage(offScreenBmp);
                                       
                    SolidBrush myBrush = new SolidBrush(this.BackColor);
                    g.FillRectangle(myBrush, 0, 0, this.Width, this.Height);
                    myBrush.Dispose();

                    Pen BorderDark = new Pen(Color.FromArgb(93, 93, 93));
                    Pen BorderLight = new Pen(Color.FromArgb(112, 112, 112));

                    Pen InsideWhite = new Pen(Color.FromArgb(255, 255, 255));
                    Pen InsideDark = new Pen(Color.FromArgb(63, 63, 63));
                    Pen InsideSmoke = new Pen(Color.FromArgb(193, 193, 193));
                    Pen InsideGray = new Pen(Color.FromArgb(151, 151, 151));

                    if (Orientation() == Horz) {
                        int y = ClientRectangle.Height / 2;

                        if (Minimum > Maximum)
                        {
                            g.DrawLine(InsideDark, new Point(1, y - 1), new Point(BTN_Thumb.Left + BTN_Thumb.Width / 2, y - 1));
                            g.DrawLine(InsideWhite, new Point(BTN_Thumb.Left + 1 + BTN_Thumb.Width / 2, y - 1), new Point(ClientRectangle.Width - 2, y - 1));
                            g.DrawLine(InsideGray, new Point(1, y), new Point(BTN_Thumb.Left + BTN_Thumb.Width / 2, y));
                            g.DrawLine(InsideSmoke, new Point(BTN_Thumb.Left + 1 + BTN_Thumb.Width / 2, y), new Point(ClientRectangle.Width - 2, y));
                        }
                        else
                        {
                            g.DrawLine(InsideWhite, new Point(1, y - 1), new Point(BTN_Thumb.Left + BTN_Thumb.Width / 2, y - 1));
                            g.DrawLine(InsideDark, new Point(BTN_Thumb.Left + 1 + BTN_Thumb.Width / 2, y - 1), new Point(ClientRectangle.Width - 2, y - 1));
                            g.DrawLine(InsideSmoke, new Point(1, y), new Point(BTN_Thumb.Left + BTN_Thumb.Width / 2, y));
                            g.DrawLine(InsideGray, new Point(BTN_Thumb.Left + 1 + BTN_Thumb.Width / 2, y), new Point(ClientRectangle.Width - 2, y));
                        }
                        g.DrawLine(BorderDark, new Point(0, y + 1), new Point(0, y - 2));
                        g.DrawLine(BorderDark, new Point(0, y - 2), new Point(ClientRectangle.Width - 1, y - 2));
                        g.DrawLine(BorderLight, new Point(1, y + 1), new Point(ClientRectangle.Width - 1, y + 1));
                        g.DrawLine(BorderLight, new Point(ClientRectangle.Width - 1, y - 2), new Point(ClientRectangle.Width - 1, y + 1));
                    }
                    else {
                        int x = ClientRectangle.Width / 2;

                        if (Minimum > Maximum)
                        {
                            g.DrawLine(InsideDark, new Point(x - 1, 1), new Point(x - 1, BTN_Thumb.Top + BTN_Thumb.Width / 2));
                            g.DrawLine(InsideGray, new Point(x, 1), new Point(x, BTN_Thumb.Top + BTN_Thumb.Width / 2));
                            g.DrawLine(InsideWhite, new Point(x - 1, BTN_Thumb.Top + 1 + BTN_Thumb.Width / 2), new Point(x - 1, ClientRectangle.Height - 2));
                            g.DrawLine(InsideSmoke, new Point(x, BTN_Thumb.Top + 1 + BTN_Thumb.Width / 2), new Point(x, ClientRectangle.Height - 2));
                        }
                        else
                        {
                            g.DrawLine(InsideWhite, new Point(x - 1, 1), new Point(x - 1, BTN_Thumb.Top + BTN_Thumb.Width / 2));
                            g.DrawLine(InsideSmoke, new Point(x, 1), new Point(x, BTN_Thumb.Top + BTN_Thumb.Width / 2));
                            g.DrawLine(InsideDark, new Point(x - 1, BTN_Thumb.Top + 1 + BTN_Thumb.Width / 2), new Point(x - 1, ClientRectangle.Height - 2));
                            g.DrawLine(InsideGray, new Point(x, BTN_Thumb.Top + 1 + BTN_Thumb.Width / 2), new Point(x, ClientRectangle.Height - 2));
                        }
                        g.DrawLine(BorderDark, new Point(x - 2, 0), new Point(x + 1, 0));
                        g.DrawLine(BorderDark, new Point(x - 2, 0), new Point(x - 2, ClientRectangle.Height - 1));
                        g.DrawLine(BorderLight, new Point(x + 1, 1), new Point(x + 1, ClientRectangle.Height - 1));
                        g.DrawLine(BorderLight, new Point(x + 1, ClientRectangle.Height - 1), new Point(x - 2, ClientRectangle.Height - 1));
                    }

                    // Draw thumb tracker
                    Bitmap bmp = new Bitmap(BTN_Thumb.BackgroundImage);
                    bmp.MakeTransparent(Color.FromArgb(255, 0, 255));
                    Rectangle srceRect = new Rectangle(0, 0, BTN_Thumb.Width, BTN_Thumb.Height);
                    Rectangle destRect = new Rectangle(BTN_Thumb.Left, BTN_Thumb.Top, BTN_Thumb.Width, BTN_Thumb.Height);
                    g.DrawImage(bmp, destRect, srceRect, GraphicsUnit.Pixel);
                    bmp.Dispose();

                    BorderDark.Dispose();
                    BorderLight.Dispose();
                    InsideWhite.Dispose();
                    InsideSmoke.Dispose();
                    InsideDark.Dispose();
                    InsideGray.Dispose();

                    g.Dispose();

                    // Swap memory bitmap (End double buffer)
                    g = Graphics.FromHdc(m.WParam);
                    g.DrawImage(offScreenBmp, 0, 0);
                    g.Dispose();
                    offScreenBmp.Dispose();

                    break;

                default:
                    base.WndProc(ref m);
                    break;
            }
        }

//----------------------------------------
        [Category("Action"), Description("Occurs when the slider is moved")]
        public event EventHandler ValueChanged;

        private void SendNotification()
        {
            if (ValueChanged != null)
            {
                ValueChanged(this, new EventArgs());
            }
            else
            {
                Api.SendMessage(Api.GetForegroundWindow(), Api.WM_COMMAND, (uint)this.Handle, (int)this.Handle);
            }
        }
//----------------------------------------

        private void SetThumbLocation()
        {
            Point pos = PointToClient(Cursor.Position);

            if (Orientation() == Horz)
            {
                BTN_Thumb.Left = Math.Min(Math.Max(pos.X - BTN_Thumb.Width / 2, 0), BTN_Thumb.Parent.Width - BTN_Thumb.Width);

                int range = ClientRectangle.Width - BTN_Thumb.Width;
                double increment = (maximum - minimum) / range;
                value = (increment * BTN_Thumb.Left) + minimum;
            }
            else
            {
                BTN_Thumb.Top = Math.Min(Math.Max(pos.Y - BTN_Thumb.Height / 2, 0), BTN_Thumb.Parent.Height - BTN_Thumb.Height);

                int range = ClientRectangle.Height - BTN_Thumb.Height;
                double increment = (maximum - minimum) / range;
                value = (increment * BTN_Thumb.Top) + minimum;
            }
            Value = value;

            if (WasValue != (int)value)
            {
                this.Invalidate();
                SendNotification();
                WasValue = (int)value;
            }
        }

        private void THUMB_MouseDown(object sender, MouseEventArgs e)
        {
            ThumbMoving = true;
        }
        
        private bool CheckOverThumb(int x, int y)
        {
            Api.RECT r = new Api.RECT();
            r.left = BTN_Thumb.Left;
            r.top = BTN_Thumb.Top;
            r.right = r.left + BTN_Thumb.Width;
            r.bottom = r.top + BTN_Thumb.Height;
            Api.POINT p = new Api.POINT();
            p.x = x; p.y = y;
            return (Api.PtInRect(ref r, p));
        }

        private void THUMB_MouseMove(object sender, MouseEventArgs e)
        {
            if (ThumbMoving) SetThumbLocation();

            if (CheckOverThumb(e.X, e.Y)) {
                toolTip.SetToolTip(this, ((int)value).ToString()); }
            else {
                toolTip.SetToolTip(this, "");
            }

        }

        private void TRACK_MouseDown(object sender, MouseEventArgs e)
        {
            ThumbMoving = true;
            SetThumbLocation();
        }

        private void THUMB_MouseUp(object sender, MouseEventArgs e)
        {
            ThumbMoving = false;
        }

        // Retrieve the control orientation
        private bool Orientation()
        {
            bool orientation = Vert;
            if (this.Width > this.Height) orientation = Horz;
            return orientation;
        }

        public double Minimum
        {
            get
            {
                return (minimum);
            }
            set
            {
                double minimumBackup = minimum;
                minimum = value;
                ShowThumbPos();
            }
        }

        public double Maximum
        {
            get
            {
                return (maximum);
            }
            set
            {
                double maximumBackup = maximum;
                maximum = value;
                ShowThumbPos();
            }
        }

        public double Value
        {
            get
            {
                return (value);
            }
            set
            {
                double valueBackup = this.value;
                if (minimum > maximum)
                {
                    this.value = Math.Max(Math.Min(value, minimum), maximum);
                }
                else
                {
                    this.value = Math.Max(Math.Min(value, maximum), minimum);
                }
                ShowThumbPos();
            }
        }

        private void ShowThumbPos()
        {
            if (Orientation() == Horz)
            {
                int range = ClientRectangle.Width - BTN_Thumb.Width;
                double increment = (maximum - minimum) / range;
                if (increment == 0) {
                    BTN_Thumb.Left = 0; }
                else {
                BTN_Thumb.Left = (int)((value - minimum) / increment);
                }
            }
            else
            {
                int range = ClientRectangle.Height - BTN_Thumb.Height;
                double increment = (maximum - minimum) / range;
                if (increment == 0) { 
                    BTN_Thumb.Top = 0; }
                else {
                BTN_Thumb.Top = (int)((value - minimum) / increment);
                }
            }
            this.Invalidate();
        }

    }
}
